
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ComplaintsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const complaints = await db.complaints.create(
            {
                id: data.id || undefined,
        
        complaint_number: data.complaint_number
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        reporter_name: data.reporter_name
        ||
        null
            ,
            
        reporter_contact: data.reporter_contact
        ||
        null
            ,
            
        complaint_description: data.complaint_description
        ||
        null
            ,
            
        serious_injury_or_death: data.serious_injury_or_death
        ||
        false
        
            ,
            
        malfunction: data.malfunction
        ||
        false
        
            ,
            
        reportable_to_authority: data.reportable_to_authority
        ||
        false
        
            ,
            
        received_at: data.received_at
        ||
        null
            ,
            
        closed_at: data.closed_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await complaints.setProduct( data.product || null, {
            transaction,
        });
        
        await complaints.setOwner( data.owner || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.complaints.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: complaints.id,
            },
            data.attachments,
            options,
        );
        

        return complaints;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const complaintsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                complaint_number: item.complaint_number
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                reporter_name: item.reporter_name
            ||
            null
            ,
            
                reporter_contact: item.reporter_contact
            ||
            null
            ,
            
                complaint_description: item.complaint_description
            ||
            null
            ,
            
                serious_injury_or_death: item.serious_injury_or_death
            ||
            false
        
            ,
            
                malfunction: item.malfunction
            ||
            false
        
            ,
            
                reportable_to_authority: item.reportable_to_authority
            ||
            false
        
            ,
            
                received_at: item.received_at
            ||
            null
            ,
            
                closed_at: item.closed_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const complaints = await db.complaints.bulkCreate(complaintsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < complaints.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.complaints.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: complaints[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return complaints;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const complaints = await db.complaints.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.complaint_number !== undefined) updatePayload.complaint_number = data.complaint_number;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.reporter_name !== undefined) updatePayload.reporter_name = data.reporter_name;
        
        
        if (data.reporter_contact !== undefined) updatePayload.reporter_contact = data.reporter_contact;
        
        
        if (data.complaint_description !== undefined) updatePayload.complaint_description = data.complaint_description;
        
        
        if (data.serious_injury_or_death !== undefined) updatePayload.serious_injury_or_death = data.serious_injury_or_death;
        
        
        if (data.malfunction !== undefined) updatePayload.malfunction = data.malfunction;
        
        
        if (data.reportable_to_authority !== undefined) updatePayload.reportable_to_authority = data.reportable_to_authority;
        
        
        if (data.received_at !== undefined) updatePayload.received_at = data.received_at;
        
        
        if (data.closed_at !== undefined) updatePayload.closed_at = data.closed_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await complaints.update(updatePayload, {transaction});

        
        
        if (data.product !== undefined) {
            await complaints.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        
        if (data.owner !== undefined) {
            await complaints.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.complaints.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: complaints.id,
            },
            data.attachments,
            options,
        );
        

        return complaints;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const complaints = await db.complaints.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of complaints) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of complaints) {
                await record.destroy({transaction});
            }
        });


        return complaints;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const complaints = await db.complaints.findByPk(id, options);

        await complaints.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await complaints.destroy({
            transaction
        });

        return complaints;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const complaints = await db.complaints.findOne(
            { where },
            { transaction },
        );

        if (!complaints) {
            return complaints;
        }

        const output = complaints.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.product = await complaints.getProduct({
            transaction
        });
        
        
        output.owner = await complaints.getOwner({
            transaction
        });
        
        
        output.attachments = await complaints.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              product_name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.complaint_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'complaints',
                        'complaint_number',
                        filter.complaint_number,
                    ),
                };
            }
            
            if (filter.reporter_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'complaints',
                        'reporter_name',
                        filter.reporter_name,
                    ),
                };
            }
            
            if (filter.reporter_contact) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'complaints',
                        'reporter_contact',
                        filter.reporter_contact,
                    ),
                };
            }
            
            if (filter.complaint_description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'complaints',
                        'complaint_description',
                        filter.complaint_description,
                    ),
                };
            }
            

            
            

            
            if (filter.received_atRange) {
                const [start, end] = filter.received_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    received_at: {
                    ...where.received_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    received_at: {
                    ...where.received_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.closed_atRange) {
                const [start, end] = filter.closed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    closed_at: {
                    ...where.closed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    closed_at: {
                    ...where.closed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.serious_injury_or_death) {
                where = {
                    ...where,
                serious_injury_or_death: filter.serious_injury_or_death,
            };
            }
            
            if (filter.malfunction) {
                where = {
                    ...where,
                malfunction: filter.malfunction,
            };
            }
            
            if (filter.reportable_to_authority) {
                where = {
                    ...where,
                reportable_to_authority: filter.reportable_to_authority,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.complaints.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'complaints',
                        'complaint_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.complaints.findAll({
            attributes: [ 'id', 'complaint_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['complaint_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.complaint_number,
        }));
    }

    
};

